"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var createNewAction = function createNewAction(_ref) {
  var action = _ref.action;
  var method = _ref.method;

  var newAction = _extends({}, action);
  newAction.method = method;
  delete newAction[method];
  delete newAction.onRequest;
  delete newAction.onResponse;
  delete newAction.onError;
  return newAction;
};

var dispatchOnRequest = exports.dispatchOnRequest = function dispatchOnRequest(_ref2) {
  var action = _ref2.action;
  var store = _ref2.store;
  var method = _ref2.method;

  if (action.onRequest) {
    var newAction = createNewAction({ action: action, method: method });
    newAction.type = action.onRequest;
    store.dispatch(newAction);
  }
};

var dispatchOnResponse = exports.dispatchOnResponse = function dispatchOnResponse(_ref3) {
  var action = _ref3.action;
  var store = _ref3.store;
  var response = _ref3.response;
  var method = _ref3.method;

  if (action.onResponse) {
    var newAction = createNewAction({ action: action, method: method });
    newAction.type = action.onResponse;
    newAction.payload = response.data;
    store.dispatch(newAction);
  }
};

var dispatchOnError = exports.dispatchOnError = function dispatchOnError(_ref4) {
  var action = _ref4.action;
  var store = _ref4.store;
  var response = _ref4.response;
  var method = _ref4.method;

  if (action.onError) {
    var newAction = createNewAction({ action: action, method: method });
    newAction.type = action.onError;
    newAction.payload = response.data;
    newAction.status = response.status;
    store.dispatch(newAction);
  }
};